<template>
    <div class="context">
        <el-page-header @back="goBack" content="关联手机号"></el-page-header>
        <div class="panel">
            <br>
            <h5> {{regionName}}</h5>
        </div>
        <div class="change">
            <el-button @click="addMember" type="primary">新增手机号</el-button>
            <el-button @click="editList">编辑手机号</el-button>
        </div>
        <div class="table">
            <el-table
                    :data="tableData"
                    border
                    is-horizontal-resize
                    :default-sort="{prop: 'date', order: 'descending'}"
                    element-loading-background="rgba(0, 0, 0, 0.8)"
                    class=""
                    @selection-change="handleSelectionChange" @current-change="clickChange"

            >
                <el-table-column label="选择" width="55">
                    <template slot-scope="scope">
                        <el-radio v-model="tableRadio" :label="scope.row"><i></i></el-radio>
                    </template>
                </el-table-column>
                <el-table-column
                        type="index"
                        label="序号"
                        align="center"
                        width="50">
                </el-table-column>
                <el-table-column
                        prop="UserName"
                        label="主账号用户名"
                >
                </el-table-column>
                <el-table-column
                        prop="UserPhone"
                        label="手机号"
                >
                </el-table-column>
                <el-table-column
                        prop="Status"
                        label="状态"
                >
                    <!--1：启用  8：暂停  9：删除-->
                    <template slot-scope="scope">
                        <span v-if="scope.row.Status == 1" style="color: yellowgreen">启用</span>
                        <span v-if="scope.row.Status == 8" style="color: yellow">暂停</span>
                        <span v-if="scope.row.Status == 9" style="color: red">删除</span>
                    </template>
                </el-table-column>
                <el-table-column
                        prop="Memo"
                        label="备注"
                >
                </el-table-column>
                <el-table-column
                        prop="UserPhone"
                        label="操作">
                    <template slot-scope="scope">
                        <el-button type="danger" size="mini"
                                   @click="pauseRowDel(scope.row)">
                            删除
                        </el-button>
                    </template>
                </el-table-column>
            </el-table>
            <br>
            <el-pagination
                    background
                    :total="pageination.total"
                    :page-size="pageination.pageItem"
                    @current-change="pageChange"
            ></el-pagination>
        </div>
        <el-dialog :title="dialogTitle" :visible.sync="dialogMemberVisible" width="650px">
            <div class="dialogContent">
                <div class="">
                    <el-form ref="form" :model="form" label-width="160px">
                        <el-form-item label="手机号">
                            <el-input v-model="form.phone"></el-input>
                        </el-form-item>
                        <el-form-item label="备注">
                            <el-input v-model="form.memo" placeholder="姓名或家庭关系"></el-input>
                        </el-form-item>
                    </el-form>
                </div>
            </div>
            <div class="dialogFooter">
                <el-button type="primary" size="small" v-if="form.btnType == 0" @click="confirmMember">确定</el-button>
                <el-button type="primary" size="small" v-if="form.btnType == 1" @click="confirmEditMember">确定
                </el-button>
                <el-button size="small" @click="dialogMemberVisible = false">取消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
    import Global from '../Global.js'
    import {
        testTable,
        ShopManagerStatusEdit,
        VipUserAssociatedPhoneSimpleQuery,
        VipUserAssociatedPhoneAdd,
        EditShopVenueEquip,
        VipUserAssociatedPhoneEdit,
        VipUserAssociatedPhoneDel,
        VipUserAssociatedPhoneStatusEdit
    } from "../api/getApiRes";

    let qs = require('qs');
    export default {
        data() {
            return {
                regionName: '',
                dialogVisible: false,
                dialogMemberVisible: false,
                dialogTitle: '新增手机号',
                // panel 配置项目
                multipleSelection: [],
                tableRadio: [],
                pageination: {
                    pageItem: 10,
                    pageoptions: pageOptions(),
                    total: 100,
                    pageIndex: 1,
                },
                form: {
                    phone: '',
                    memo: '',
                    eqId: '',
                    eqSn: '',
                    name: '',
                    version: '',
                    userCode: '',
                    shopId: '',
                    pId: '',
                    btnType: 0,
                    equipType: 1,
                },
                options: [
                    {value: 1, label: 'TVBox'},
                    {value: 2, label: 'BLEHub'},
                ],
                shops: [],
                tableData: [],
                serachBtnStatus: false,
            }
        },
        mounted() {
            this.regionName = this.$route.query.name;
            this.getTableQuery();
        },
        methods: {
            goBack() {
                this.$router.push({
                    path: '/member', query: {}
                });
            },
            // 删除
            pauseRowDel(row) {
                let that = this;
                let param = {
                    token: localStorage.token,
                    userId: this.$route.query.userId,
                    pId: row.PId,
                };
                let postdata = qs.stringify(param);
                this.$confirm('此操作将永久删除该手机号, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    VipUserAssociatedPhoneDel(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的手机号已删除！',
                                type: 'success'
                            });
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo + ' 错误码：' + json.Code);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消删除'
                    });
                });
            },
            clearForm() {
                // clear
                this.form.name = '';
                this.form.phone = '';
                this.form.memo = '';
                this.form.userCode = '';
                this.form.shopId = '';
                this.form.eqSn = '';
                this.form.version = '';
                this.form.pId = '';
                this.form.equipType = 1;
            },
            handleSelectionChange(val) {
                this.multipleSelection = val;
            },
            // 新增手机号
            addMember() {
                this.clearForm();
                this.dialogMemberVisible = true;
                this.form.btnType = 0;
                this.dialogTitle = '新增手机号'
            },
            clickChange(item) {
                this.tableRadio = item
            },
            // 删除
            delList() {
                let that = this;
                if (this.tableRadio.length == 0) {
                    this.$message.error("请先选中一条记录");
                    return false
                }
                let userId = this.tableRadio.Id;

                let param = {
                    key: localStorage.ServiceKey,
                    shopId: localStorage.ServiceId,
                    svId: this.$route.query.svId,
                    eqId: this.tableRadio.EqId,
                    status: 9,//1：启用 8：暂停 9：删除
                };
                let postdata = qs.stringify(param);

                this.$confirm('此操作将永久删除该手机号, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    VipUserAssociatedPhoneStatusEdit(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的手机号已删除！',
                                type: 'success'
                            });
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo + ' 错误码：' + json.Code);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消删除'
                    });
                });
            },
            // 编辑
            editList() {
                let that = this;
                this.clearForm();
                if (this.tableRadio.length == 0) {
                    this.$message.error("请先选中一条记录");
                    return false
                }
                let row = this.tableRadio;
                this.form.shopid = row.ShopId;
                this.form.userId = row.Id;
                this.form.name = row.Name;
                this.form.phone = row.UserPhone;
                this.form.userCode = row.Usercode;
                this.form.pId = row.PId;
                this.form.password = '';
                this.form.eqId = row.EqId;
                this.form.equipType = row.EquipType;
                this.form.memo = row.Memo;
                this.form.adminType = row.AdminType;
                this.dialogVisible = true;
                this.dialogTitle = '编辑手机号';
                this.form.btnType = 1;
                this.dialogMemberVisible = true
            },
            // 确认提交新增手机号
            confirmMember() {
                let that = this;

                if (!that.form.phone) {
                    this.$message.error('错了哦，手机号码不能为空');
                    return false
                }
                if (!globalCheckPhone(that.form.phone)) {
                    this.$message.error('错了哦，手机号格式不正确');
                    return false
                }
                if (that.form.memo) {
                    if (that.form.memo.length > 200) {
                        this.$message.error('错了哦，备注字数超过200个字');
                        return false
                    }
                }

                let param = {
                    token: localStorage.token,
                    userId: this.$route.query.userId,
                    phone: this.form.phone,
                    memo: this.form.memo,
                };
                let postdata = qs.stringify(param);
                VipUserAssociatedPhoneAdd(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogMemberVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '所属设备添加成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo + ' 错误码：' + json.Code);
                    }
                })
            },
            confirmEditMember() {
                let that = this;
                console.log(that.form.version.length);

                // checkNum
                if (!that.form.phone) {
                    this.$message.error('错了哦，手机号码不能为空');
                    return false
                }
                if (!globalCheckPhone(that.form.phone)) {
                    this.$message.error('错了哦，手机号格式不正确');
                    return false
                }
                if (that.form.memo) {
                    if (that.form.memo.length > 200) {
                        this.$message.error('错了哦，备注字数超过200个字');
                        return false
                    }
                }
                let param = {
                    token: localStorage.token,
                    userId: this.$route.query.userId,
                    phone: this.form.phone,
                    memo: this.form.memo,
                    pId: this.form.pId,
                };
                let postdata = qs.stringify(param);
                VipUserAssociatedPhoneEdit(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogMemberVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '手机号信息编辑成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo + ' 错误码：' + json.Code);
                    }
                })
            },
            // 查询按钮
            query() {
                // 按钮倒计时
                let that = this;
                that.serachBtnStatus = true;
                let totalTime = 2;
                let clock = window.setInterval(() => {
                    totalTime--;
                    if (totalTime < 0) {
                        totalTime = 2;
                        that.serachBtnStatus = false;
                    }
                }, 1000);

                this.getTableQuery();
                this.$message.success('查询完毕');
            },
            // 页面数据查询
            getTableQuery() {
                let that = this;
                that.loading = true;
                let param = {
                    token: localStorage.token,
                    userId: this.$route.query.userId,
                };
                let postdata = qs.stringify(param);
                VipUserAssociatedPhoneSimpleQuery(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.loading = false;
                        if (json.Rs) {
                            that.allTableData = json.Rs;
                            that.recordsTotal = json.Rs.length;
                        } else {
                            that.allTableData = [];
                            that.recordsTotal = 0;
                        }
                        // 设置分页数据
                        that.setPaginations();
                    } else {
                        that.$message.error(json.Memo + ' 错误码：' + json.Code);
                    }
                })
            },
            // 设置分页数据
            setPaginations() {
                // 分页属性
                let that = this;
                that.pageination.total = that.recordsTotal;
                // 默认分页
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
            },
            // 每页显示数量
            handleSizeChange() {
                let that = this;
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
                that.draw = that.pageination.pageItem;
                that.getTableQuery();
            },
            // 翻页
            pageChange(pageIndex) {
                let that = this;
                // 获取当前页
                let index = that.pageination.pageItem * (pageIndex - 1);
                // 数据总数
                let nums = that.pageination.pageItem * pageIndex;
                // 容器
                let tables = [];
                for (var i = index; i < nums; i++) {
                    if (that.allTableData[i]) {
                        tables.push(that.allTableData[i])
                    }
                    this.tableData = tables;
                }
                that.start = index * that.draw;
                // that.getTableQuery();
            },
            // 自动排序
            sortChange(params) {
                console.log(params)
            },
            // 过滤时间
            filterFmtDate(value, row, column) {
                let that = this;
                return nonTfmtDate(column, 11);
            },
            // 暂停
            pause(row) {
                let that = this;
                console.log(row);
                this.$confirm('是否暂停设备' + row.EqSn + '？', '暂停操作', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {

                    let param = {
                        key: localStorage.ServiceKey,
                        shopId: localStorage.ServiceId,
                        svId: this.$route.query.svId,
                        eqId: row.EqId,
                        status: 8,//1：启用 8：暂停 9：删除
                    };

                    let postdata = qs.stringify(param);
                    VipUserAssociatedPhoneStatusEdit(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: row.EqSn + '暂停成功！',
                                type: 'success'
                            });
                            // table 重载
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo + ' 错误码：' + json.Code);
                        }
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消暂停'
                    });
                });
            },
            // 开启
            run(row) {
                let that = this;
                this.$confirm('是否开启设备' + row.EqSn + '？', '开启操作', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {

                    let param = {
                        key: localStorage.ServiceKey,
                        shopId: localStorage.ServiceId,
                        svId: this.$route.query.svId,
                        eqId: row.EqId,
                        status: 1,//1：启用 8：暂停 9：删除
                    };

                    let postdata = qs.stringify(param);
                    VipUserAssociatedPhoneStatusEdit(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: row.EqSn + '开启成功！',
                                type: 'success'
                            });
                            // table 重载
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo + ' 错误码：' + json.Code);
                        }
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消开启'
                    });
                });
            },
        },
        watch: {
            $route(to) {
                if (to.name == 'relevancePhone') {
                    this.getTableQuery();
                }
            },
        },
    }
</script>

<style scoped>
    @import "../assets/css/panel.css";

    .context {
        /* height: 770px; */
        overflow-y: scroll;

        display: block;
        margin: 0 auto;
        background-color: #fff !important;
        padding: 30px;
        padding-bottom: 60px;
    }

    .panel-body {
        padding: 20px;
        background: #F0F2F5;
    }

    .change {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        padding-top: 10px;
        padding-bottom: 10px;
    }

    .change button {
        float: left;
    }

    .change button.pull-right {
        float: right;
    }

    .dialogTitle {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        color: #000000;
        font-size: 18px;
        text-align: center;
    }

    .dialogTitle em {
        float: none;
        font-style: normal;
        color: #3799FF;
        margin: 0;
    }

    /deep/ .el-transfer-panel__item .el-checkbox__input {
        left: 40px;
    }

    .dialogFooter {
        width: 90%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        margin-top: 10px;
    }

    .dialogFooter button {
        float: right;
        margin-left: 10px;
    }

    /deep/ .el-date-editor .el-range__icon {
        line-height: 22px;
    }

    .panel /deep/ .el-date-editor .el-range-separator {
        line-height: 22px;
    }

    /deep/ .el-select {
        width: 100%;
    }

    .panel h5 {
        font-size: 24px;
    }

    /*ipad only*/
    @media only screen and (max-width: 1366px) {
        .panel /deep/ .el-date-editor--daterange {
            width: 100%;
        }
    }

</style>
